package lu.tlk.objectdb_test.admin;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Deactivate;

import lu.tlk.objectdb_test.api.PersonAdminAPI;
import lu.tlk.objectdb_test.entity.PersonEntity;

@Component(
	immediate = true
	, service = PersonAdminAPI.class)
public class PersonAdmin implements PersonAdminAPI {

	private EntityManagerFactory entityManagerFactory;
	private EntityManager entityManager;
	
	@Activate
	public void activate() {
		entityManagerFactory = Persistence.createEntityManagerFactory("objectdb://localhost:6136/technolink.odb;user=admin;password=admin");
		entityManager = entityManagerFactory.createEntityManager();
	}
	
	@Deactivate
	public void deactivate() {
		entityManager.close();
		entityManagerFactory.close();
	}
	
	@Override
	public void savePerson(final PersonEntity person) {
		entityManager.getTransaction().begin();
		entityManager.persist(person);
		entityManager.getTransaction().commit();
	}

	@Override
	public void loadPerson(final Long id) {
	}

}
